var Opcodes=Java.type('org.objectweb.asm.Opcodes')
var InsnList=Java.type('org.objectweb.asm.tree.InsnList')
var VarInsnNode=Java.type('org.objectweb.asm.tree.VarInsnNode')
var MethodInsnNode=Java.type('org.objectweb.asm.tree.MethodInsnNode')
var MethodNode=Java.type('org.objectweb.asm.tree.MethodNode')
var InsnNode=Java.type('org.objectweb.asm.tree.InsnNode')
var FieldInsnNode=Java.type('org.objectweb.asm.tree.FieldInsnNode')
var LabelNode=Java.type('org.objectweb.asm.tree.LabelNode')
var LocalVariableNode=Java.type('org.objectweb.asm.tree.LocalVariableNode')
var Label=Java.type('org.objectweb.asm.Label')
var JumpInsnNode=Java.type('org.objectweb.asm.tree.JumpInsnNode')
var FieldNode=Java.type('org.objectweb.asm.tree.FieldNode')

function clientPacketRedirectTransformCustomPatch(methodNode, patchList){
	var instructions = methodNode.instructions
	for(var i = 0; i < instructions.size(); i++) {
		var insn = instructions.get(i);
		if(insn.getOpcode() == Opcodes.INVOKESTATIC) {
			if(insn.owner.equals("net/minecraft/network/protocol/PacketUtils") && (insn.name.equals("ensureRunningOnSameThread") || insn.name.equals("m_131363_"))) {
				instructions.insert(insn, patchList);
				break;
			}
		}
	}
}

function clientPacketRedirectTransformCustom(methodNode, methodInsnNode, localVariable){
	var patchList = new InsnList()
	patchList.add(new VarInsnNode(Opcodes.ALOAD, localVariable))
	//INVOKESTATIC xaero/common/core/LaunchPlugin.chunkUpdateCallback (Lnet/minecraft/client/renderer/chunk/ChunkRenderDispatcher$ChunkRender;)V
	patchList.add(methodInsnNode)
	clientPacketRedirectTransformCustomPatch(methodNode, patchList)
}

function clientPacketRedirectTransformCustomDouble(methodNode, methodInsnNode, localVariable, localVariable2){
	var patchList = new InsnList()
	patchList.add(new VarInsnNode(Opcodes.ALOAD, localVariable))
	patchList.add(new VarInsnNode(Opcodes.ALOAD, localVariable2))
	patchList.add(methodInsnNode)
	clientPacketRedirectTransformCustomPatch(methodNode, patchList)
}

function clientPacketRedirectTransform(methodNode, methodInsnNode){
	clientPacketRedirectTransformCustom(methodNode, methodInsnNode, 1)
}

function addCustomGetter2(classNode, fieldName, fieldDesc, methodName, staticField){
	var methods = classNode.methods
	var getterNode = new MethodNode(Opcodes.ACC_PUBLIC, methodName, "()" + fieldDesc, null, null)
	var labelNode1 = new LabelNode()
	var labelNode2 = new LabelNode()
	var instructions = getterNode.instructions
	instructions.add(labelNode1)
	if(!staticField)
		instructions.add(new VarInsnNode(Opcodes.ALOAD, 0))
	instructions.add(new FieldInsnNode(staticField ? Opcodes.GETSTATIC : Opcodes.GETFIELD, classNode.name, fieldName, fieldDesc))
	if(fieldDesc === "J")
		instructions.add(new InsnNode(Opcodes.LRETURN))
	else if(fieldDesc === "I")
		instructions.add(new InsnNode(Opcodes.IRETURN))
	else if(fieldDesc === "F")
		instructions.add(new InsnNode(Opcodes.FRETURN))
	else if(fieldDesc === "D")
		instructions.add(new InsnNode(Opcodes.DRETURN))
	else
		instructions.add(new InsnNode(Opcodes.ARETURN))
	instructions.add(labelNode2)
	getterNode.localVariables.add(new LocalVariableNode("this", "L" + classNode.name + ";", null, labelNode1, labelNode2, 0))
	getterNode.maxStack = 1
	getterNode.maxLocals = 1
	methods.add(getterNode)
}

function addCustomGetter(classNode, fieldName, fieldDesc, methodName){
	addCustomGetter2(classNode, fieldName, fieldDesc, methodName, false)
}

function addGetter(classNode, fieldName, fieldDesc){
	addCustomGetter(classNode, fieldName, fieldDesc, "get" + (fieldName.charAt(0) + "").toUpperCase() + fieldName.substring(1))
}

function addSetter(classNode, fieldName, fieldDesc){
	var methods = classNode.methods
	var setterNode = new MethodNode(Opcodes.ACC_PUBLIC, "set" + (fieldName.charAt(0) + "").toUpperCase() + fieldName.substring(1), "(" + fieldDesc +  ")V", null, null)
	var labelNode1 = new LabelNode()
	var labelNode2 = new LabelNode()
	var instructions = setterNode.instructions
	instructions.add(labelNode1)
	instructions.add(new VarInsnNode(Opcodes.ALOAD, 0))
	instructions.add(new VarInsnNode(Opcodes.ALOAD, 1))
	instructions.add(new FieldInsnNode(Opcodes.PUTFIELD, classNode.name, fieldName, fieldDesc))
	instructions.add(new InsnNode(Opcodes.RETURN))
	instructions.add(labelNode2)
	setterNode.localVariables.add(new LocalVariableNode("this", "L" + classNode.name + ";", null, labelNode1, labelNode2, 0))
	setterNode.localVariables.add(new LocalVariableNode("value", fieldDesc, null, labelNode1, labelNode2, 1))
	setterNode.maxStack = 2
	setterNode.maxLocals = 2
	methods.add(setterNode)
}

function modelRenderDetectionTransform(methodNode){
	var instructions = methodNode.instructions
	var patchList = new InsnList()
	patchList.add(new VarInsnNode(Opcodes.ALOAD, 0))
	patchList.add(new VarInsnNode(Opcodes.ALOAD, 2))
	patchList.add(new VarInsnNode(Opcodes.ILOAD, 5))
	patchList.add(new MethodInsnNode(Opcodes.INVOKESTATIC, 'xaero/common/core/XaeroMinimapCore', 
			"onEntityIconsModelRenderDetection", "(Lnet/minecraft/client/model/Model;Lcom/mojang/blaze3d/vertex/VertexConsumer;I)V"))
	instructions.insert(instructions.get(0), patchList)
	return methodNode
}

function modelRendererDoRenderTransform(methodNode){
	var instructions = methodNode.instructions
	var patchList = new InsnList()
	patchList.add(new VarInsnNode(Opcodes.ALOAD, 0))
	patchList.add(new VarInsnNode(Opcodes.ILOAD, 5))
	patchList.add(new MethodInsnNode(Opcodes.INVOKESTATIC, 'xaero/common/core/XaeroMinimapCore', 
			"onEntityIconsModelPartRenderDetection", "(Lnet/minecraft/client/model/geom/ModelPart;I)V"))
	instructions.insert(instructions.get(0), patchList)
	return methodNode
}

function addSendCommandCallback(methodNode, retBoolean){
	var instructions = methodNode.instructions
	var MY_LABEL = new LabelNode(new Label())
	var patchList = new InsnList()
	patchList.add(new VarInsnNode(Opcodes.ALOAD, 1))
	patchList.add(new MethodInsnNode(Opcodes.INVOKESTATIC, 'xaero/common/core/XaeroMinimapCore', 
			"onLocalPlayerCommand", "(Ljava/lang/String;)Z"))
	if(retBoolean)
		patchList.add(new InsnNode(Opcodes.DUP))
	patchList.add(new JumpInsnNode(Opcodes.IFEQ, MY_LABEL))
	if(retBoolean)
		patchList.add(new InsnNode(Opcodes.IRETURN))
	else
		patchList.add(new InsnNode(Opcodes.RETURN))
	patchList.add(MY_LABEL)
	if(retBoolean)
		patchList.add(new InsnNode(Opcodes.POP))
	instructions.insert(instructions.get(0), patchList)
	
	return methodNode
}

function initializeCoreMod() {
	return {
		'xaero_chunkclass': {
			'target' : {
				'type' : 'CLASS',
				'name' : 'net.minecraft.world.level.chunk.LevelChunk'
			},
			'transformer' : function(classNode){
				var fields = classNode.fields
				fields.add(new FieldNode(Opcodes.ACC_PUBLIC, "xaero_chunkClean", "Z", null, 0))
				return classNode
			}
		},
		'xaero_clientplaynethandler_handleblockchange': {
			'target' : {
                'type': 'METHOD',
                'class': 'net.minecraft.client.multiplayer.ClientPacketListener',
                'methodName': 'handleBlockUpdate',
                'methodDesc' : '(Lnet/minecraft/network/protocol/game/ClientboundBlockUpdatePacket;)V'
			},
			'transformer' : function(methodNode){
				clientPacketRedirectTransform(methodNode, new MethodInsnNode(Opcodes.INVOKESTATIC, 'xaero/common/core/XaeroMinimapCore', 
						"onBlockChange", "(Lnet/minecraft/network/protocol/game/ClientboundBlockUpdatePacket;)V"))
				return methodNode
			}
		},
		'xaero_clientplaynethandler_handlemultiblockchange': {
			'target' : {
                'type': 'METHOD',
                'class': 'net.minecraft.client.multiplayer.ClientPacketListener',
                'methodName': 'handleChunkBlocksUpdate',
                'methodDesc' : '(Lnet/minecraft/network/protocol/game/ClientboundSectionBlocksUpdatePacket;)V'
			},
			'transformer' : function(methodNode){
				clientPacketRedirectTransform(methodNode, new MethodInsnNode(Opcodes.INVOKESTATIC, 'xaero/common/core/XaeroMinimapCore', 
						"onMultiBlockChange", "(Lnet/minecraft/network/protocol/game/ClientboundSectionBlocksUpdatePacket;)V"))
				return methodNode
			}
		},
		'xaero_clientplaynethandler_updatelevelchunk': {
			'target' : {
                'type': 'METHOD',
                'class': 'net.minecraft.client.multiplayer.ClientPacketListener',
                'methodName': 'updateLevelChunk',
                'methodDesc' : '(IILnet/minecraft/network/protocol/game/ClientboundLevelChunkPacketData;)V'
			},
			'transformer' : function(methodNode){
				var patchList = new InsnList();
				patchList.add(new VarInsnNode(Opcodes.ILOAD, 1))
				patchList.add(new VarInsnNode(Opcodes.ILOAD, 2))
				patchList.add(new VarInsnNode(Opcodes.ALOAD, 3))
				patchList.add(new MethodInsnNode(Opcodes.INVOKESTATIC, 'xaero/common/core/XaeroMinimapCore', 
						"onChunkData", "(IILnet/minecraft/network/protocol/game/ClientboundLevelChunkPacketData;)V"))
				methodNode.instructions.insert(methodNode.instructions.get(0), patchList)
				return methodNode
			}
		},
		'xaero_clientplaynethandler_handlelevelchunkwithlight': {
			'target' : {
                'type': 'METHOD',
                'class': 'net.minecraft.client.multiplayer.ClientPacketListener',
                'methodName': 'handleLevelChunkWithLight',
                'methodDesc' : '(Lnet/minecraft/network/protocol/game/ClientboundLevelChunkWithLightPacket;)V'
			},
			'transformer' : function(methodNode){
				clientPacketRedirectTransform(methodNode, new MethodInsnNode(Opcodes.INVOKESTATIC, 'xaero/common/core/XaeroMinimapCore', 
						"onHandleLevelChunkWithLight", "(Lnet/minecraft/network/protocol/game/ClientboundLevelChunkWithLightPacket;)V"))
				return methodNode
			}
		},
		'xaero_clientplaynethandler_handlelightupdatepacket': {
			'target' : {
                'type': 'METHOD',
                'class': 'net.minecraft.client.multiplayer.ClientPacketListener',
                'methodName': 'handleLightUpdatePacket',
                'methodDesc' : '(Lnet/minecraft/network/protocol/game/ClientboundLightUpdatePacket;)V'
			},
			'transformer' : function(methodNode){
				clientPacketRedirectTransform(methodNode, new MethodInsnNode(Opcodes.INVOKESTATIC, 'xaero/common/core/XaeroMinimapCore', 
						"onHandleLightUpdatePacket", "(Lnet/minecraft/network/protocol/game/ClientboundLightUpdatePacket;)V"))
				return methodNode
			}
		},
		'xaero_clientplaynethandler_queuelightremoval': {
			'target' : {
                'type': 'METHOD',
                'class': 'net.minecraft.client.multiplayer.ClientPacketListener',
                'methodName': 'queueLightRemoval',
                'methodDesc' : '(Lnet/minecraft/network/protocol/game/ClientboundForgetLevelChunkPacket;)V'
			},
			'transformer' : function(methodNode){
				var patchList = new InsnList();
				patchList.add(new VarInsnNode(Opcodes.ALOAD, 1))
				patchList.add(new MethodInsnNode(Opcodes.INVOKESTATIC, 'xaero/common/core/XaeroMinimapCore', 
						"onQueueLightRemoval", "(Lnet/minecraft/network/protocol/game/ClientboundForgetLevelChunkPacket;)V"))
				methodNode.instructions.insert(methodNode.instructions.get(0), patchList)
				return methodNode
			}
		},
		'xaero_clientplaynethandler_handlespawnpoint': {
			'target' : {
                'type': 'METHOD',
                'class': 'net.minecraft.client.multiplayer.ClientPacketListener',
                'methodName': 'handleSetSpawn',
                'methodDesc' : '(Lnet/minecraft/network/protocol/game/ClientboundSetDefaultSpawnPositionPacket;)V'
			},
			'transformer' : function(methodNode){
				clientPacketRedirectTransform(methodNode, new MethodInsnNode(Opcodes.INVOKESTATIC, 'xaero/common/core/XaeroMinimapCore', 
						"onSpawn", "(Lnet/minecraft/network/protocol/game/ClientboundSetDefaultSpawnPositionPacket;)V"))
				return methodNode
			}
		},
		'xaero_playerentity_iswearing': {
			'target' : {
                'type': 'METHOD',
                'class': 'net.minecraft.world.entity.player.Player',
                'methodName': 'isModelPartShown',
                'methodDesc' : '(Lnet/minecraft/world/entity/player/PlayerModelPart;)Z'
			},
			'transformer' : function(methodNode){
				//var MY_LABEL = new LabelNode(new Label())
				//var insnToInsert = new InsnList()
				//insnToInsert.add(new VarInsnNode(Opcodes.ALOAD, 0))
				//insnToInsert.add(new VarInsnNode(Opcodes.ALOAD, 1))
				//insnToInsert.add(new MethodInsnNode(Opcodes.INVOKESTATIC, "xaero/common/core/XaeroMinimapCore", "isWearing", "(Lnet/minecraft/world/entity/player/Player;Lnet/minecraft/world/entity/player/PlayerModelPart;)Ljava/lang/Boolean;"))
				//insnToInsert.add(new InsnNode(Opcodes.DUP))
				//insnToInsert.add(new JumpInsnNode(Opcodes.IFNULL, MY_LABEL))
				//insnToInsert.add(new MethodInsnNode(Opcodes.INVOKEVIRTUAL, "java/lang/Boolean", "booleanValue", "()Z"))
				//insnToInsert.add(new InsnNode(Opcodes.IRETURN))
				//insnToInsert.add(MY_LABEL)
				//insnToInsert.add(new InsnNode(Opcodes.POP))
				//methodNode.instructions.insert(methodNode.instructions.get(0), insnToInsert)
				return methodNode
			}
		},
		'xaero_clientplaynethandlerclass': {
			'target' : {
				'type' : 'CLASS',
				'name' : 'net.minecraft.client.multiplayer.ClientPacketListener'
			},
			'transformer' : function(classNode){
				var fields = classNode.fields
				classNode.interfaces.add("xaero/common/core/IXaeroMinimapClientPlayNetHandler")
				fields.add(new FieldNode(Opcodes.ACC_PRIVATE, "xaero_minimapSession", "Lxaero/common/XaeroMinimapSession;", null, null))
				addGetter(classNode, "xaero_minimapSession", "Lxaero/common/XaeroMinimapSession;")
				addSetter(classNode, "xaero_minimapSession", "Lxaero/common/XaeroMinimapSession;")
				
				return classNode
			}
		},
		'xaero_clientplaynethandler_handlejoingame': {
			'target' : {
                'type': 'METHOD',
                'class': 'net.minecraft.client.multiplayer.ClientPacketListener',
                'methodName': 'handleLogin',
                'methodDesc' : '(Lnet/minecraft/network/protocol/game/ClientboundLoginPacket;)V'
			},
			'transformer' : function(methodNode){
				clientPacketRedirectTransformCustomDouble(methodNode, new MethodInsnNode(Opcodes.INVOKESTATIC, 'xaero/common/core/XaeroMinimapCore', 
						"onPlayNetHandler", "(Lnet/minecraft/client/multiplayer/ClientPacketListener;Lnet/minecraft/network/protocol/game/ClientboundLoginPacket;)V"), 0, 1)
				return methodNode
			}
		},
		'xaero_clientplaynethandler_close': {
			'target' : {
                'type': 'METHOD',
                'class': 'net.minecraft.client.multiplayer.ClientPacketListener',
                'methodName': 'close',
                'methodDesc' : '()V'
			},
			'transformer' : function(methodNode){
				var instructions = methodNode.instructions
				var patchList = new InsnList()
				patchList.add(new VarInsnNode(Opcodes.ALOAD, 0))
				patchList.add(new MethodInsnNode(Opcodes.INVOKESTATIC, 'xaero/common/core/XaeroMinimapCore', 
						"onPlayNetHandlerCleanup", "(Lnet/minecraft/client/multiplayer/ClientPacketListener;)V"))
				instructions.insert(instructions.get(0), patchList)
				return methodNode
			}
		},
		'xaero_clientworldclass': {
			'target' : {
				'type' : 'CLASS',
				'name' : 'net.minecraft.client.multiplayer.ClientLevel'
			},
			'transformer' : function(classNode){
				var fields = classNode.fields
				classNode.interfaces.add("xaero/common/minimap/mcworld/IXaeroMinimapClientWorld")
				fields.add(new FieldNode(Opcodes.ACC_PRIVATE, "xaero_minimapData", "Lxaero/common/minimap/mcworld/MinimapClientWorldData;", null, null))
				addGetter(classNode, "xaero_minimapData", "Lxaero/common/minimap/mcworld/MinimapClientWorldData;")
				addSetter(classNode, "xaero_minimapData", "Lxaero/common/minimap/mcworld/MinimapClientWorldData;")
				
				return classNode
			}
		},
		'xaero_clientplayerentity_respawnplayer': {
			'target' : {
                'type': 'METHOD',
                'class': 'net.minecraft.client.player.LocalPlayer',
                'methodName': 'respawn',
                'methodDesc' : '()V'
			},
			'transformer' : function(methodNode){
				var instructions = methodNode.instructions
				var patchList = new InsnList()
				patchList.add(new VarInsnNode(Opcodes.ALOAD, 0))
				patchList.add(new MethodInsnNode(Opcodes.INVOKESTATIC, 'xaero/common/core/XaeroMinimapCore', 
						"beforeRespawn", "(Lnet/minecraft/world/entity/player/Player;)V"))
				instructions.insert(instructions.get(0), patchList)
				return methodNode
			}
		},
		'xaero_smultiblockchangepacketclass': {//1.16.2 and newer
			'target' : {
				'type' : 'CLASS',
				'name' : 'net.minecraft.network.protocol.game.ClientboundSectionBlocksUpdatePacket'
			},
			'transformer' : function(classNode){
				
				classNode.interfaces.add("xaero/common/core/IXaeroMinimapSMultiBlockChangePacket")
				var obfName = "f_132980_";
				var normalName = "sectionPos";
				for(var i = 0; i < classNode.fields.size(); i++){
					var f = classNode.fields.get(i)
					if(f.name.equals(obfName) || f.name.equals(normalName)){
						addCustomGetter(classNode, f.name, "Lnet/minecraft/core/SectionPos;", "xaero_mm_getSectionPos")
						break
					}
				}
				return classNode
			}
		},
		'xaero_playerlist_sendworldinfo': {
			'target' : {
                'type': 'METHOD',
                'class': 'net.minecraft.server.players.PlayerList',
                'methodName': 'sendLevelInfo',
                'methodDesc' : '(Lnet/minecraft/server/level/ServerPlayer;Lnet/minecraft/server/level/ServerLevel;)V'
			},
			'transformer' : function(methodNode){
				var instructions = methodNode.instructions
				var patchList = new InsnList()
				patchList.add(new VarInsnNode(Opcodes.ALOAD, 1))
				patchList.add(new MethodInsnNode(Opcodes.INVOKESTATIC, 'xaero/common/server/core/XaeroMinimapServerCore', 
						"onServerWorldInfo", "(Lnet/minecraft/world/entity/player/Player;)V"))
				instructions.insert(instructions.get(0), patchList)
				return methodNode
			}
		},
		'xaero_bossoverlaygui_render': {
			'target' : {
                'type': 'METHOD',
                'class': 'net.minecraft.client.gui.components.BossHealthOverlay',
                'methodName': 'render',
                'methodDesc' : '(Lnet/minecraft/client/gui/GuiGraphics;)V'
			},
			'transformer' : function(methodNode){
				var instructions = methodNode.instructions
				var foundFirst = false
				var guiHeightInsn
				for(var i = 0; i < instructions.size(); i++) {
					var insn = instructions.get(i)
					if(insn.getOpcode() == Opcodes.INVOKEVIRTUAL && "net/minecraft/client/gui/GuiGraphics".equals(insn.owner) && "guiHeight".equals(insn.name)){
						guiHeightInsn = insn
						break
					}
				}
				if(guiHeightInsn == undefined)
					return methodNode
				
				var patchList = new InsnList()
				patchList.add(new VarInsnNode(Opcodes.ILOAD, 4))
				patchList.add(new MethodInsnNode(Opcodes.INVOKESTATIC, 'xaero/common/core/XaeroMinimapCore', 
						"onBossHealthRender", "(I)V"))
				instructions.insertBefore(guiHeightInsn, patchList)
				return methodNode
			}
		},
		'xaero_model_render': {
			'target' : {
                'type': 'METHOD',
                'class': 'net.minecraft.client.model.Model',
                'methodName': 'renderToBuffer',
				'methodDesc' : '(Lcom/mojang/blaze3d/vertex/PoseStack;Lcom/mojang/blaze3d/vertex/VertexConsumer;III)V',
			},
			'transformer' : function(methodNode){
				return modelRenderDetectionTransform(methodNode)
			}
		},
		'xaero_modelrenderer_dorender': {
			'target' : {
                'type': 'METHOD',
                'class': 'net.minecraft.client.model.geom.ModelPart',
                'methodName': 'compile',
				'methodDesc' : '(Lcom/mojang/blaze3d/vertex/PoseStack$Pose;Lcom/mojang/blaze3d/vertex/VertexConsumer;III)V',
			},
			'transformer' : function(methodNode){
				return modelRendererDoRenderTransform(methodNode)
			}
		},
		'xaero_cyclebutton': {
			'target' : {
				'type' : 'CLASS',
				'name' : 'net.minecraft.client.gui.components.CycleButton'
			},
			'transformer' : function(classNode){
				var fields = classNode.fields
				classNode.interfaces.add("xaero/common/gui/IXaeroClickableWidget")
				fields.add(new FieldNode(Opcodes.ACC_PRIVATE, "xaero_tooltip", "Ljava/util/function/Supplier;", null, null))
				addGetter(classNode, "xaero_tooltip", "Ljava/util/function/Supplier;")
				addSetter(classNode, "xaero_tooltip", "Ljava/util/function/Supplier;")
				
				return classNode
			}
		},
		'xaero_levelstorageaccess_deletelevel': {
			'target' : {
                'type': 'METHOD',
                'class': 'net.minecraft.world.level.storage.LevelStorageSource$LevelStorageAccess',
                'methodName': 'deleteLevel',
				'methodDesc' : '()V',
			},
			'transformer' : function(methodNode){
				var instructions = methodNode.instructions
				var patchList = new InsnList()
				patchList.add(new VarInsnNode(Opcodes.ALOAD, 0))
				patchList.add(new MethodInsnNode(Opcodes.INVOKESTATIC, 'xaero/common/core/XaeroMinimapCore', 
						"onDeleteWorld", "(Lnet/minecraft/world/level/storage/LevelStorageSource$LevelStorageAccess;)V"))
				for(var i = instructions.size() - 1; i >= 0; i--){
					if(instructions.get(i).getOpcode() == Opcodes.RETURN){
						instructions.insertBefore(instructions.get(i), patchList)
						break
					}
				}
				return methodNode
			}
		},
		'xaero_clientlistener_sendcommand': {
			'target' : {
                'type': 'METHOD',
                'class': 'net.minecraft.client.multiplayer.ClientPacketListener',
                'methodName': 'sendCommand',
                'methodDesc' : '(Ljava/lang/String;)V'
			},
			'transformer' : function(methodNode){
				return addSendCommandCallback(methodNode, false)
			}
		},
		'xaero_clientlistener_commandunsigned': {
			'target' : {
                'type': 'METHOD',
                'class': 'net.minecraft.client.multiplayer.ClientPacketListener',
                'methodName': 'sendUnsignedCommand',
                'methodDesc' : '(Ljava/lang/String;)Z'
			},
			'transformer' : function(methodNode){
				return addSendCommandCallback(methodNode, true)
			}
		},
		'xaero_gui_handlesystemchat': {
			'target' : {
                'type': 'METHOD',
                'class': 'net.minecraft.client.multiplayer.chat.ChatListener',
                'methodName': 'handleSystemMessage',
                'methodDesc' : '(Lnet/minecraft/network/chat/Component;Z)V'
			},
			'transformer' : function(methodNode){
				var instructions = methodNode.instructions
				var MY_LABEL = new LabelNode(new Label())
				var patchList = new InsnList()
				patchList.add(new VarInsnNode(Opcodes.ALOAD, 1))
				patchList.add(new MethodInsnNode(Opcodes.INVOKESTATIC, 'xaero/common/core/XaeroMinimapCore', 
						"onSystemChat", "(Lnet/minecraft/network/chat/Component;)Z"))
				patchList.add(new JumpInsnNode(Opcodes.IFEQ, MY_LABEL))
				patchList.add(new InsnNode(Opcodes.RETURN))
				patchList.add(MY_LABEL)
				
				for(var i = 0; i < instructions.size(); i++) {
					var insn = instructions.get(i);
					if(insn.getOpcode() == Opcodes.INVOKEVIRTUAL) {
						if(insn.owner.equals("net/minecraft/client/gui/components/ChatComponent") && (insn.name.equals("addMessage") || insn.name.equals("m_93785_"))) {
							instructions.insertBefore(insn, patchList);
							break;
						}
					}
				}
				return methodNode
			}
		},
		'xaero_gui_handledisguisedchatmessage': {
			'target' : {
                'type': 'METHOD',
                'class': 'net.minecraft.client.multiplayer.chat.ChatListener',
                'methodName': 'handleDisguisedChatMessage',
                'methodDesc' : '(Lnet/minecraft/network/chat/Component;Lnet/minecraft/network/chat/ChatType$Bound;)V'
			},
			'transformer' : function(methodNode){
				var instructions = methodNode.instructions
				var MY_LABEL = new LabelNode(new Label())
				var patchList = new InsnList()
				patchList.add(new VarInsnNode(Opcodes.ALOAD, 2))
				patchList.add(new VarInsnNode(Opcodes.ALOAD, 1))
				patchList.add(new MethodInsnNode(Opcodes.INVOKESTATIC, 'xaero/common/core/XaeroMinimapCore', 
						"onHandleDisguisedChatMessage", "(Lnet/minecraft/network/chat/ChatType$Bound;Lnet/minecraft/network/chat/Component;)Z"))
				patchList.add(new JumpInsnNode(Opcodes.IFNE, MY_LABEL))
				patchList.add(new InsnNode(Opcodes.RETURN))
				patchList.add(MY_LABEL)
				
				instructions.insert(instructions.get(0), patchList)
				return methodNode
			}
		},
		'xaero_minecraftserver': {
			'target' : {
				'type' : 'CLASS',
				'name' : 'net.minecraft.server.MinecraftServer'
			},
			'transformer' : function(classNode){
				var fields = classNode.fields
				classNode.interfaces.add("xaero/common/server/IMinecraftServer")
				fields.add(new FieldNode(Opcodes.ACC_PRIVATE, "xaeroMinimapServerData", "Lxaero/common/server/MinecraftServerData;", null, null))
				addGetter(classNode, "xaeroMinimapServerData", "Lxaero/common/server/MinecraftServerData;")
				addSetter(classNode, "xaeroMinimapServerData", "Lxaero/common/server/MinecraftServerData;")
				return classNode
			}
		},
		'xaero_serverplayer': {
			'target' : {
				'type' : 'CLASS',
				'name' : 'net.minecraft.server.level.ServerPlayer'
			},
			'transformer' : function(classNode){
				var fields = classNode.fields
				classNode.interfaces.add("xaero/common/server/player/IServerPlayer")
				fields.add(new FieldNode(Opcodes.ACC_PRIVATE, "xaeroMinimapPlayerData", "Lxaero/common/server/player/ServerPlayerData;", null, null))
				addGetter(classNode, "xaeroMinimapPlayerData", "Lxaero/common/server/player/ServerPlayerData;")
				addSetter(classNode, "xaeroMinimapPlayerData", "Lxaero/common/server/player/ServerPlayerData;")
				return classNode
			}
		},
		'xaero_minecraftclient': {
			'target' : {
				'type' : 'CLASS',
				'name' : 'net.minecraft.client.Minecraft'
			},
			'transformer' : function(classNode){
				var fields = classNode.fields
				classNode.interfaces.add("xaero/common/core/IXaeroMinimapMinecraftClient")
				
				var obfName = "f_91021_";
				var normalName = "fps";
				for(var i = 0; i < classNode.fields.size(); i++){
					var f = classNode.fields.get(i)
					if(f.name.equals(obfName) || f.name.equals(normalName)){
						addCustomGetter2(classNode, f.name, "I", "getXaeroMinimap_fps", true)
						break
					}
				}
				return classNode
			}
		},
		'xaero_buffersource': {
			'target' : {
				'type' : 'CLASS',
				'name' : 'net.minecraft.client.renderer.MultiBufferSource$BufferSource'
			},
			'transformer' : function(classNode){
				var fields = classNode.fields
				classNode.interfaces.add("xaero/common/core/IBufferSource")
				fields.add(new FieldNode(Opcodes.ACC_PRIVATE, "xaero_lastRenderType", "Lnet/minecraft/client/renderer/RenderType;", null, null))
				addGetter(classNode, "xaero_lastRenderType", "Lnet/minecraft/client/renderer/RenderType;")
				addSetter(classNode, "xaero_lastRenderType", "Lnet/minecraft/client/renderer/RenderType;")
				return classNode
			}
		},
		'xaero_buffersource_getbuffer': {
			'target' : {
				'type': 'METHOD',
				'class': 'net.minecraft.client.renderer.MultiBufferSource$BufferSource',
				'methodName': 'getBuffer',
				'methodDesc' : '(Lnet/minecraft/client/renderer/RenderType;)Lcom/mojang/blaze3d/vertex/VertexConsumer;'
			},
			'transformer' : function(methodNode){
				var instructions = methodNode.instructions
				var patchList = new InsnList()
				patchList.add(new VarInsnNode(Opcodes.ALOAD, 0))
				patchList.add(new VarInsnNode(Opcodes.ALOAD, 1))
				patchList.add(new MethodInsnNode(Opcodes.INVOKESTATIC, 'xaero/common/core/XaeroMinimapCore',
						"onBufferSourceGetBuffer", "(Lxaero/common/core/IBufferSource;Lnet/minecraft/client/renderer/RenderType;)V"))
				instructions.insert(instructions.get(0), patchList)
				return methodNode
			}
		}
	}
}